package cn.ezhizao.project.system.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import cn.ezhizao.project.business.innerTurnover.domain.BizInnerTurnover;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.validation.constraints.Email;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.ArrayList;
import java.util.List;

/**
 * 部门表 sys_dept
 *
 * @author ruoyi
 */
@TableName("sys_dept")
public class SysDept extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 部门ID
     */
    @TableId(type = IdType.AUTO)
    private Long deptId;

    /**
     * 租户id
     */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;
    /**
     * 父部门ID
     */
    private Long parentId;

    /**
     * 祖级列表
     */
    private String ancestors;


    /**
     * 部门名称
     */
    private String deptName;
    /**
     * 部门助记码
     */
    private String deptKey;
    /**
     * 统一社会信用编码
     */
    private String deptCode;

    /**
     * 显示顺序
     */
    private Integer orderNum;


    /**
     * 联系电话
     */
    private String phone;

    /**
     * 邮箱
     */
    private String email;

    /**
     * 部门状态:0正常,1停用
     */
    private String status;


    private String isWorkSection;
    private Long autoAllocation;


    /**
     * 删除标志（0代表存在 2代表删除）
     */
    private String delFlag;

    /**
     * 父部门名称
     */
    private String parentName;

    /**
     * 角色名称
     */
    private String role;
    private Long workshopId;
    private Long[] ids;
    @TableField(exist = false)
    private Long userId;

    private Long equimentFlag;
    @TableField(exist = false)
    private String nickName;
    @TableField(exist = false)
    private String userName;
    private Integer isSortPackaging;
    @TableField(exist = false)
    private String name;
    @TableField(exist = false)
    private String mnemonicCode;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getMnemonicCode() {
        return mnemonicCode;
    }

    public void setMnemonicCode(String mnemonicCode) {
        this.mnemonicCode = mnemonicCode;
    }

    public Integer getIsSortPackaging() {
        return isSortPackaging;
    }

    public void setIsSortPackaging(Integer isSortPackaging) {
        this.isSortPackaging = isSortPackaging;
    }

    @TableField(exist = false)
    private Integer hasPackageLine;

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getNickName() {
        return nickName;
    }

    public void setNickName(String nickName) {
        this.nickName = nickName;
    }

    private List<BizInnerTurnover> innerTurnoverList;

    public List<BizInnerTurnover> getInnerTurnoverList() {
        return innerTurnoverList;
    }

    public void setInnerTurnoverList(List<BizInnerTurnover> innerTurnoverList) {
        this.innerTurnoverList = innerTurnoverList;
    }

    private Boolean getType = false;

    public Boolean getGetType() {
        return getType;
    }

    public void setGetType(Boolean getType) {
        this.getType = getType;
    }

    public Long getAutoAllocation() {
        return autoAllocation;
    }

    public void setAutoAllocation(Long autoAllocation) {
        this.autoAllocation = autoAllocation;
    }

    /**
     * 是否为企业
     */
    private String type;

    private List<Long> deptIds;
    /**
     * 字典标签
     */
    @Excel(name = "字典标签")
    @TableField(exist = false)
    private String Label;

    /**
     * 字典键值
     */
    @Excel(name = "字典键值")
    @TableField(exist = false)
    private Long Value;

    @TableField(exist = false)
    private String Code;
    @TableField(exist = false)
    private Long dayworkId;
    private Integer isCentralizedTurnover;
    private Integer isOutsourcing;
    private Long supplierId;
    @TableField(exist =false)
    private String supplierName;
    @TableField(exist = false)
    private Integer isInnerOutsource;

    public Integer getIsInnerOutsource() {
        return isInnerOutsource;
    }

    public void setIsInnerOutsource(Integer isInnerOutsource) {
        this.isInnerOutsource = isInnerOutsource;
    }

    public String getSupplierName() {
        return supplierName;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    public Integer getIsOutsourcing() {
        return isOutsourcing;
    }

    public void setIsOutsourcing(Integer isOutsourcing) {
        this.isOutsourcing = isOutsourcing;
    }

    public Long getSupplierId() {
        return supplierId;
    }

    public void setSupplierId(Long supplierId) {
        this.supplierId = supplierId;
    }

    public Integer getIsCentralizedTurnover() {
        return isCentralizedTurnover;
    }

    public void setIsCentralizedTurnover(Integer isCentralizedTurnover) {
        this.isCentralizedTurnover = isCentralizedTurnover;
    }

    public Long getDayworkId() {
        return dayworkId;
    }

    public void setDayworkId(Long dayworkId) {
        this.dayworkId = dayworkId;
    }

    public String getCode() {
        return Code;
    }

    public void setCode(String code) {
        Code = code;
    }

    public Long getWorkshopId() {
        return workshopId;
    }

    public void setWorkshopId(Long workshopId) {
        this.workshopId = workshopId;
    }

    public Long getEquimentFlag() {
        return equimentFlag;
    }

    public void setEquimentFlag(Long equimentFlag) {
        this.equimentFlag = equimentFlag;
    }

    public String getLabel() {
        return Label;
    }

    public void setLabel(String label) {
        Label = label;
    }

    public Long getValue() {
        return Value;
    }

    public void setValue(Long value) {
        Value = value;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public Long[] getIds() {
        return ids;
    }

    public void setIds(Long[] ids) {
        this.ids = ids;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }


    public String getRole() {
        return role;
    }

    public void setRole(String role) {
        this.role = role;
    }

    @Override
    public Long getTenantId() {
        return tenantId;
    }

    @Override
    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    /**
     * 子部门
     */
    private List<SysDept> children = new ArrayList<SysDept>();

    public Long getDeptId() {
        return deptId;
    }

    public void setDeptId(Long deptId) {
        this.deptId = deptId;
    }

    public Long getParentId() {
        return parentId;
    }

    public void setParentId(Long parentId) {
        this.parentId = parentId;
    }

    public String getAncestors() {
        return ancestors;
    }

    public void setAncestors(String ancestors) {
        this.ancestors = ancestors;
    }

    @NotBlank(message = "部门名称不能为空")
    @Size(min = 0, max = 30, message = "部门名称长度不能超过30个字符")
    public String getDeptName() {
        return deptName;
    }

    public void setDeptName(String deptName) {
        this.deptName = deptName;
    }

    @NotNull(message = "显示顺序不能为空")
    public Integer getOrderNum() {
        return orderNum;
    }

    public void setOrderNum(Integer orderNum) {
        this.orderNum = orderNum;
    }


    @Size(min = 0, max = 11, message = "联系电话长度不能超过11个字符")
    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    @Email(message = "邮箱格式不正确")
    @Size(min = 0, max = 50, message = "邮箱长度不能超过50个字符")
    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(String delFlag) {
        this.delFlag = delFlag;
    }

    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    public List<SysDept> getChildren() {
        return children;
    }

    public void setChildren(List<SysDept> children) {
        this.children = children;
    }

    public String getDeptCode() {
        return deptCode;
    }

    public void setDeptCode(String deptCode) {
        this.deptCode = deptCode;
    }

    public String getIsWorkSection() {
        return isWorkSection;
    }

    public void setIsWorkSection(String isWorkSection) {
        this.isWorkSection = isWorkSection;
    }

    public List<Long> getDeptIds() {
        return deptIds;
    }

    public void setDeptIds(List<Long> deptIds) {
        this.deptIds = deptIds;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                       .append("deptId", getDeptId())
                       .append("parentId", getParentId())
                       .append("tenantId", getTenantId())
                       .append("ancestors", getAncestors())
                       .append("deptName", getDeptName())
                       .append("orderNum", getOrderNum())
                       .append("isWorkSection", getIsWorkSection())
                       .append("phone", getPhone())
                       .append("email", getEmail())
                       .append("status", getStatus())
                       .append("delFlag", getDelFlag())
                       .append("createBy", getCreateBy())
                       .append("createTime", getCreateTime())
                       .append("updateBy", getUpdateBy())
                       .append("updateTime", getUpdateTime())
                       .toString();
    }

    public Integer getHasPackageLine() {
        return hasPackageLine;
    }

    public void setHasPackageLine(Integer hasPackageLine) {
        this.hasPackageLine = hasPackageLine;
    }

    public String getDeptKey() {
        return deptKey;
    }

    public void setDeptKey(String deptKey) {
        this.deptKey = deptKey;
    }
}
